#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <avr/pgmspace.h>
#include <stdlib.h>
#include <inttypes.h>
#include <stdio.h>
#include <string.h>
#include "ir_out.h"
#include "helpers.h"
#include "initport.h"
#include "uart.h"

/******************* Liste der Macros ***************************/

  #define endjahr 7
  #define endmonat 4
  
  
  #define setbit(ADDRESS,BIT) (ADDRESS |= (1<<BIT))
  #define clearbit(ADDRESS,BIT) (ADDRESS &= ~(1<<BIT))
  #define checkbit(ADDRESS,BIT) (ADDRESS & (1<<BIT))

  
/******************* Liste der Proceduren ***************************/
  volatile char serial_in = 0x00;
  volatile char Key = 0;
  char expectstring=0 , zeichenzaehler = 0x00, tabcount =0;
  char tag=0, monat=0, jahr=0, stunde=0, minute=0, sekunde=0; 
  char demost[5]="0000";
  volatile char status = 0x00;
  /* 	bit0	letztes Zeichen
		bit1	uart - Interrupt
		bit2	erstes Zeichen-Ende
		bit3	execint
		bit4	
		bit5	
		bit6	
		bit7	
  */
  
  char step = 0x00;
  
  
  char status2 = 0x00;
  /* 	bit0	prx erkannt warte auf Ende
		bit1	kein iea
		bit2	kein Uiso
		bit3	Kein Riso
		bit4	Riso >310Meg
		bit5	SK2
		bit6	RSL > 31Ohm
		bit7	EL1
   */
  
  float rsl = 0.0 , riso = 0.0 , uiso = 0.0, iea = 0.0;
 
  int  autodelay,   menu=1;
  volatile int nokey=0; 
  volatile long Timer1 =0;

  char sendstring[30];
 
/******************* Liste der Proceduren ***************************/

void daten_auswerten_0 (void);
void daten_auswerten_1 (void);
void daten_auswerten_2 (void);
void daten_anfordern_x (void);
void daten_anfordern_y (void);
void byteshift (void);
void daten_ausgeben_ir (void);


SIGNAL(SIG_OUTPUT_COMPARE2)
	{
		++Timer1;			
		if (nokey > 0) nokey--;
		setbit(status,3);
	}


SIGNAL(SIG_INTERRUPT0)
	{
	if (!nokey) {Key= 1; keyhelp();}
	}

SIGNAL(SIG_INTERRUPT1)
	{
	if (!nokey) {Key= 2; keyhelp();}
	}

void daten_auswerten_0 (void)
	{
	if(demost[0] =='P' && demost[1] == 'R' && demost[2] == 'X') setbit(status2,0);
	if(checkbit(status2,0) && checkbit(status,0)) 
		{
		step = 1;
		stunde = 0;
		minute = 0;
		sekunde = 0;
		rsl = 0.0;
		riso = 0.0;
		clearbit(status2,0);
		clearbit(status,0);
		}
	clearbit(PORTC,PC4);
	}




void daten_auswerten_1 (void)
	{
	
	if(tabcount == 3 && demost[0] ==';')
		{
		if (demost[1] =='V')  
			setbit(status2,7);
		else	
			clearbit(status2,7);
		}
	if(tabcount == 4 && demost[0] ==';' && demost[1] !=';' && zeichenzaehler == 1) 
		{
		tag=(((demost[1] - 48)*10) + (demost[2] - 48));
		}
	if(tabcount == 4 && demost[0] =='.' && demost[0] !=';' && zeichenzaehler == 4) 
		{
		monat=(((demost[1] - 48)*10) + (demost[2] - 48));
		}
	if(tabcount == 4 && demost[0] =='.' && demost[0] !=';' && zeichenzaehler == 7) 
		{
		jahr=(((demost[1] - 48)*10) + (demost[2] - 48));
		}

	if(tabcount == 5 && demost[0] ==';' && demost[1] !=';' && zeichenzaehler == 1) 
		{
		stunde=(((demost[1] - 48)*10) + (demost[2] - 48));
		}
	if(tabcount == 5 && demost[0] ==':' && demost[0] !=';' && zeichenzaehler == 4) 
		{
		minute=(((demost[1] - 48)*10) + (demost[2] - 48));
		}
	if(tabcount == 5 && demost[0] ==':' && demost[0] !=';' && zeichenzaehler == 7) 
		{
		sekunde=(((demost[1] - 48)*10) + (demost[2] - 48));
		step = 3; //test
		}

	}


/*
void daten_auswerten_2 (void)
	{

	if(tabcount == 1)			//R(sl)
		{
		
		if(zeichenzaehler ==1)
			{			
			if(demost[1] == ';') setbit(status2,5);
			else clearbit(status2,5);
			if(demost[1] == '>') 
				{
				setbit(status2,6);
				rsl=31.0;
				}
			else clearbit(status2,6);
			}
		
		if(zeichenzaehler == 4 && !checkbit(status2,6))
			{
			if(demost[1] == '.')
				{
				rsl = rsl + (demost[0]-48.0);
				}
			if(demost[2] == '.')
				{
				rsl = rsl + ((demost[0]-48.0)*10.0) + (demost[1]-48.0);
				}
			
			}
		if(demost[0] == '.' && !checkbit(status2,6)) 
			{
			if(demost[1] > 47 && demost[1] <58)
			rsl = rsl + ((demost[1]-48.0)/10.0);
			if(demost[2] > 47 && demost[2] <58)
			rsl = rsl + ((demost[2]-48.0)/100.0);
			if(demost[3] > 47 && demost[3] <58)
			rsl = rsl + ((demost[3]-48.0)/1000.0);
			}
		}

	if(tabcount == 5)				// RIso
		{		
		if(zeichenzaehler == 1)
			{
			if(demost[1] == ';') setbit(status2,3);
			else clearbit(status2,3);
			if(demost[1] == '>') 
				{
				setbit(status2,4);
				riso = 310.0;				
				}
			else 
				clearbit(status2,4);
			}			
		if(zeichenzaehler == 4  && !checkbit(status2,4))
			{
			if(demost[1] == '.')
				{
				riso = riso + (demost[0]-48.0);
				}
			if(demost[2] == '.')
				{
				riso = riso  + ((demost[0]-48.0)*10.0) + (demost[1]-48.0);
				}
			if(demost[3] == '.')
				{
				riso = riso  + ((demost[0]-48.0)*100.0) + ((demost[1]-48.0)*10.0) + (demost[2]-48.0);
				}				
			}
		if(demost[0] == '.'  && !checkbit(status2,4)) 
			{
			if(demost[1] > 47 && demost[1] <58)
			riso = riso + ((demost[1]-48.0)/10.0);
			if(demost[2] > 47 && demost[2] <58)
			riso = riso + ((demost[2]-48.0)/100.0);
			if(demost[3] > 47 && demost[3] <58)
			riso = riso + ((demost[3]-48.0)/1000.0);									
			}			
		}

	if(tabcount == 7)
		{		
		if(zeichenzaehler == 1)
			{			
			if(demost[1] == ';') setbit(status2,2);
			else clearbit(status2,2);
			}
		
		if(zeichenzaehler > 2 &&  demost[3] == 'V')
			{
			uiso = uiso + ((demost[0]-48.0)*100.0) + ((demost[1]-48.0)*10.0) + (demost[2]-48.0);
			}
		}

	if(tabcount == 15)
		{		
		if(zeichenzaehler ==1)
			{			
			if(demost[1] == ';') setbit(status2,1);
			else clearbit(status2,1);
			}
		
		if(zeichenzaehler > 2 && demost[3] == '.')
			{
			iea = iea + ((demost[1]-48.0)*10.0) + (demost[2]-48.0);
			}
		if(demost[0] == '.' && zeichenzaehler > 3) 
			{
			if(demost[1] > 47 && demost[1] <58)
			iea = iea + ((demost[1]-48.0)/10.0);
			if(demost[2] > 47 && demost[2] <58)
			iea = iea + ((demost[2]-48.0)/100.0);
			if(demost[3] > 47 && demost[3] <58)
			iea = iea + ((demost[3]-48.0)/1000.0);
			}		
		}

	
	if(tabcount > 23 )
		{
		step = 0;
		}	
	}

*/


void daten_anfordern_x (void)
	{
	zeichenzaehler = 0;
	tabcount = 0;
	step = 2;
	sprintf(sendstring,"PRX?X%c", 0x0d);
	send_string_uart(sendstring);
	}


void daten_anfordern_y (void)
	{
	pause(100);
	zeichenzaehler = 0;
	tabcount = 0;
	step = 4;	
	sprintf(sendstring,"PRX?Y%c", 0x0d);
	send_string_uart(sendstring);
	}

/*
void daten_ausgeben_ir (void)
	{

	if (checkbit(status2,5))
		sprintf(sendstring,"SK2,");
	else 
		if(checkbit(status2,6))
		sprintf(sendstring,">31.0,");
	else 
		sprintf(sendstring,"%3.3f,",(double)rsl );
	ir_string(sendstring);
	
	if (checkbit(status2,3))
		{
		sprintf(sendstring,"x,");
		}
	else
		{
		if(checkbit(status2,4))
		sprintf(sendstring,">310.0,");
		else
		sprintf(sendstring,"%3.3f,",(double)riso );
		}
	ir_string(sendstring);

	if (checkbit(status2,2))
		sprintf(sendstring,"x,");
	else
		sprintf(sendstring,"%3.0f,",(double)uiso );
	ir_string(sendstring);	
	
	if (checkbit(status2,1))
		{
		if(checkbit(status2,7))
		sprintf(sendstring,"EL1,");
		else
		sprintf(sendstring,"x,");
		}
	else
		sprintf(sendstring,"%1.3f,",(double)iea );
	ir_string(sendstring);			
	
	if (Key == 1)
	sprintf(sendstring,"1,%02d.%02d.%02d,", (int)tag,(int)monat,(int)jahr);
	else
	sprintf(sendstring,"2,%02d.%02d.%02d,", (int)tag,(int)monat,(int)jahr);
	ir_string(sendstring);			

	
	sprintf(sendstring,"%02d.%02d.%02d", (int)stunde ,(int)minute,(int)sekunde);	
	ir_string(sendstring);			
			
	clearbit(PORTC,PC4);
	clearbit(PORTC,PC2);
	
	Key = 0;
	}
*/
void byteshift (void)
	{
	demost[0] = demost[1];
	demost[1] = demost[2];
	demost[2] = demost[3];
	demost[3] = serial_in;
	clearbit(status,1);	
	
	if(demost[0] == ';') 
		{
		tabcount++;
		zeichenzaehler = 0;
		}
	if(demost[0] == '=') 
		{
		tabcount=0;
		zeichenzaehler = 0;
		}
	zeichenzaehler++;
	}




int main (void)
    {
	Initialisierung();

	pause(20000);
	Key = 0;

	while( 1)  
		{	

		if(Key != 0)
			{
			pause(500);


			if (endjahr == jahr && ((endmonat - monat) == 1))
				{
				setbit(PORTC,PC2);
				sprintf(sendstring,"DIS!0c02;Datenstecker Fehler %c", 0x0d);
				send_string_uart(sendstring);	
				pause(20000);	
				//daten_ausgeben_ir();
				sprintf(sendstring,"DIS!%c", 0x0d);
				send_string_uart(sendstring);
								
				}
			//else
			
			//if (endjahr >= jahr && endmonat >= monat) daten_ausgeben_ir();
			

			
			}
		
		
		if(checkbit(status,1))
			{
			byteshift();			
			clearbit(PORTC,PC2);
			switch(step)
				{
				case 0 : daten_auswerten_0();
					break;
				case 1 : daten_anfordern_x();
					break;
				case 2 : daten_auswerten_1();
					break;
				case 3 : daten_anfordern_y();					
					break;
				case 4 : //daten_auswerten_2();
					setbit(PORTC,PC4);
					break;
				}
			
			}					
		}
	}
	

