#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <stdlib.h>
#include <inttypes.h>
#include <stdio.h>


#define setbit(ADDRESS,BIT) (ADDRESS |= (1<<BIT))
#define clearbit(ADDRESS,BIT) (ADDRESS &= ~(1<<BIT))
#define checkbit(ADDRESS,BIT) (ADDRESS & (1<<BIT))


 extern volatile char serial_in;
 extern volatile char status;


SIGNAL(SIG_UART_RECV)
{
serial_in = UDR;
setbit(status,1);
setbit(PORTC,PC2);
}

 
void uart_init(void)
{

	setbit (UCSRB,RXCIE);
	setbit (UCSRB,RXEN);
	setbit (UCSRB,TXEN);
	UCSRC = 0x86;
	
//	UBRRH = 0x00;							//  UBBRH()	Reloadwert fr Highregister
	UBRRL = 51;							//  UBRRL= (fquarz/ (16* BAUD) ) -1 (82) Lowregister
	
}

void send_string_uart(char* data)
{
	int charcounter=0;
	
	while ((charcounter<40) && (data[charcounter] != 0x00))
		{ 	// Abbruch, sobald ein Nullstring erreicht wird
							// oder 16 Zeichen gesendet sind
		if ( checkbit(UCSRA,UDRE)) UDR = data[charcounter++];	// einzelnes Zeichen schicken
				
		}


}



